/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Mozilla Communicator client code, released
 * March 31, 1998.
 * 
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation. Portions created by Netscape are
 * Copyright (C) 1998-1999 Netscape Communications Corporation. All
 * Rights Reserved.
 */

/* This is where functions related to the 3 pane window are kept */


var msgNavigationService;

var gFolderTree;

var gStartFolderUri = null;

function IsCurrentLoadedFolder(folder)
{
	var msgfolder = folder.QueryInterface(Components.interfaces.nsIMsgFolder);
	if(msgfolder)
	{
		var folderResource = msgfolder.QueryInterface(Components.interfaces.nsIRDFResource);
		if(folderResource)
		{
			var folderURI = folderResource.Value;
			var currentLoadedFolder = GetThreadTreeFolder();
			var currentURI = currentLoadedFolder.getAttribute('ref');
			return(currentURI == folderURI);
		}
	}

	return false;
}

/* Functions related to startup */
function OnLoadMsgCenter()
{
	HideMenus();
	HideToolbarButtons();
	CreateMailWindowGlobals();
	Create3PaneGlobals();
	verifyAccounts();
	
	//InitMsgWindow();
	msgWindow.statusFeedback = statusFeedback;
	msgWindow.messageView = messageView;
	//msgWindow.msgHeaderSink = messageHeaderSink;
	msgWindow.SetDOMWindow(window);
	mailSession.AddMsgWindow(msgWindow);

	messenger.SetWindow(window, msgWindow);

	InitializeDataSources();
	InitPanes();

	accountManager.SetSpecialFoldersForIdentities();

	if(window.arguments && window.arguments[0])
	{
		gStartFolderUri = window.arguments[0];
	}
	else
	{
		gStartFolderUri = null;
	}

	setTimeout("loadStartFolder(gStartFolderUri);", 0);

}

function HideMenus()
{
	var fileAttachmentMenu=document.getElementById('fileAttachmentMenu');
	if(fileAttachmentMenu)
		fileAttachmentMenu.setAttribute("hidden", "true");

	var message_menuitem=document.getElementById('menu_showMessage');
	if(message_menuitem)
		message_menuitem.setAttribute("hidden", "true");

	var expandOrCollapseMenu = document.getElementById('menu_expandOrCollapse');
	if(expandOrCollapseMenu)
		expandOrCollapseMenu.setAttribute("hidden", "true");

	var viewMessagesMenu = document.getElementById('viewMessagesMenu');
	if(viewMessagesMenu)
		viewMessagesMenu.setAttribute("hidden", "true");

	var openMessageMenu = document.getElementById('openMessageWindowMenuitem');
	if(openMessageMenu)
		openMessageMenu.setAttribute("hidden", "true");

	var viewSortMenu = document.getElementById('viewSortMenu');
	if(viewSortMenu)
		viewSortMenu.setAttribute("hidden", "true");

	var viewThreadedMenu = document.getElementById('menu_showThreads');
	if(viewThreadedMenu)
		viewThreadedMenu.setAttribute("hidden", "true");

	var goMenu = document.getElementById('menu_Go');
	if(goMenu)
		goMenu.setAttribute("hidden", "true");

	var messageMenu = document.getElementById('menu_Message');
	if(messageMenu)
		messageMenu.setAttribute("hidden", "true");
}

function HideToolbarButtons()
{
	var toolbarSeparator1 = document.getElementById('toolbarseparator-1');
	if(toolbarSeparator1)
		toolbarSeparator1.setAttribute("hidden", "true");

	var replyButton = document.getElementById('button-reply');
	if(replyButton)
		replyButton.setAttribute("hidden", "true");

	var replyAllButton = document.getElementById('button-replyall');
	if(replyAllButton)
		replyAllButton.setAttribute("hidden", "true");

	var forwardButton = document.getElementById('button-forward');
	if(forwardButton)
		forwardButton.setAttribute("hidden", "true");

	var toolbarSeparator2 = document.getElementById('toolbarseparator-2');
	if(toolbarSeparator2)
		toolbarSeparator2.setAttribute("hidden", "true");

	var fileButtonMenu = document.getElementById('FileButtonMenu');
	if(fileButtonMenu)
		fileButtonMenu.setAttribute("hidden", "true");

	var nextButton = document.getElementById('button-next');
	if(nextButton)
		nextButton.setAttribute("hidden", "true");

	var deleteButton = document.getElementById('button-delete');
	if(deleteButton)
		deleteButton.setAttribute("hidden", "true");

	var printButton = document.getElementById('button-print');
	if(printButton)
		printButton.setAttribute("hidden", "true");

}

function OnUnloadMsgCenter()
{
	dump("\nOnUnload from XUL\nClean up ...\n");
	
	var mailSession = Components.classes[mailSessionContractID].getService();
	if(mailSession)
	{
		mailSession = mailSession.QueryInterface(Components.interfaces.nsIMsgMailSession);
		if(mailSession)
		{
			mailSession.RemoveMsgWindow(msgWindow);
		}
	}
	messenger.SetWindow(null, null);

	var msgDS = folderDataSource.QueryInterface(Components.interfaces.nsIMsgRDFDataSource);
	msgDS.window = null;

	msgDS = messageDataSource.QueryInterface(Components.interfaces.nsIMsgRDFDataSource);
	msgDS.window = null;

	msgDS = accountManagerDataSource.QueryInterface(Components.interfaces.nsIMsgRDFDataSource);
	msgDS.window = null;


  	msgWindow.closeWindow();

}


function Create3PaneGlobals()
{
	msgNavigationService = Components.classes['@mozilla.org/messenger/msgviewnavigationservice;1'].getService();
	msgNavigationService= msgNavigationService.QueryInterface(Components.interfaces.nsIMsgViewNavigationService);

}


function PerformExpandForAllOpenServers(tree)
{
	//dump("PerformExpandForAllOpenServers()\n");

	var uri = null;
	var open = null;
	var treechild = null;
	var server = null;

	if ( tree && tree.childNodes ) {
		for ( var i = tree.childNodes.length - 1; i >= 0; i-- ) {
			treechild = tree.childNodes[i];
			if (treechild.localName == 'treechildren') {
				var treeitems = treechild.childNodes;
				for ( var j = treeitems.length - 1; j >= 0; j--) {
					open = treeitems[j].getAttribute('open');
					//dump("open="+open+"\n");
					if (open == "true") {
						var isServer = (treeitems[j].getAttribute('IsServer') == "true");
						//dump("isServer="+isServer+"\n");
						if (isServer) {
							uri = treeitems[j].getAttribute('id');
							//dump("uri="+uri+"\n");
							server = GetServer(uri);
							if (server) {
								// don't do this for imap servers.
								// see bug #41943
								if (server.type != "imap") {
									//dump("PerformExpand on " + uri + "\n");
									server.PerformExpand(msgWindow);
								}
							}
						}
					}
				}
			}
		}
	}
}

function loadStartFolder(startFolderUri)
{
	//First get default account
	try
	{
		if(!startFolderUri)
		{
			var defaultAccount = accountManager.defaultAccount;

			var server = defaultAccount.incomingServer;
			var rootFolder = server.RootFolder;
			var rootMsgFolder = rootFolder.QueryInterface(Components.interfaces.nsIMsgFolder);

			//now find Inbox
			var outNumFolders = new Object();
			var inboxFolder = rootMsgFolder.getFoldersWithFlag(0x1000, 1, outNumFolders); 
			if(!inboxFolder) return;

			var resource = inboxFolder.QueryInterface(Components.interfaces.nsIRDFResource);
			startFolderUri = resource.Value;

			//first, let's see if it's already in the dom.  This will make life easier.
			//We need to make sure content is built by this time
		}
		msgNavigationService.EnsureDocumentIsLoaded(document);

		var startFolder = document.getElementById(startFolderUri);

		//if it's not here we will have to make sure it's open.
		if(!startFolder)
		{

		}

		ChangeSelection(gFolderTree, startFolder);

		// because the "open" state persists, we'll call
		// PerformExpand() for all servers that are open at startup.
		PerformExpandForAllOpenServers(gFolderTree);
	}
	catch(ex)
	{
		dump(ex);
		dump('Exception in LoadStartFolder caused by no default account.  We know about this\n');
	}

}

function InitPanes()
{
	gFolderTree = document.getElementById('folderTree');
	if(gFolderTree)
		OnLoadFolderPane();

	SetupCommandUpdateHandlers();
}

function InitializeDataSources()
{
	//Setup common mailwindow stuff.
	AddDataSources();
}

function OnLoadFolderPane()
{
	SortFolderPane('FolderColumn', 'http://home.netscape.com/NC-rdf#FolderTreeName');

	//Add folderDataSource and accountManagerDataSource to folderPane
	accountManagerDataSource = accountManagerDataSource.QueryInterface(Components.interfaces.nsIRDFDataSource);
	folderDataSource = folderDataSource.QueryInterface(Components.interfaces.nsIRDFDataSource);
	var database = GetFolderDatasource();

	database.AddDataSource(accountManagerDataSource);
	database.AddDataSource(folderDataSource);
	gFolderTree.setAttribute('ref', 'msgaccounts:/');
}

function GetFolderDatasource()
{
	var db = gFolderTree.database;
	if (!db) return false;
	return db;
}

/* Functions for accessing particular parts of the window*/
function GetFolderTree()
{
	return gFolderTree;
}

function FindInSidebar(currentWindow, id)
{
	var item = currentWindow.document.getElementById(id);
	if(item)
		return item;

	for(var i = 0; i < currentWindow.frames.length; i++)
	{
		var frameItem = FindInSidebar(currentWindow.frames[i], id);
		if(frameItem)
			return frameItem;
	}

	return null;
}

function GetThreadAndMessagePaneSplitter()
{
	alert('GetThreadAndMessagePaneSplitter');
	return null;
}

function GetUnreadCountElement()
{
	if(gUnreadCount) return gUnreadCount;
	var unreadCount = document.getElementById('unreadMessageCount');
	gUnreadCount = unreadCount;
	return unreadCount;
}
function GetTotalCountElement()
{
	if(gTotalCount) return gTotalCount;
	var totalCount = document.getElementById('totalMessageCount');
	gTotalCount = totalCount;
	return totalCount;
}
function IsThreadAndMessagePaneSplitterCollapsed()
{
	return true;
}

function FindMessenger()
{
  return messenger;
}

function RefreshThreadTreeView()
{
}

function ClearThreadTreeSelection()
{
}

function ClearMessagePane()
{
}


function GetSelectedFolder()
{
	var selection = gFolderTree.selectedItems;
	if(selection.length > 0)
		return selection[0];
	else
		return null;

}

function GetServer(uri)
{
	if (!uri) return null;
	try {
		var folder = GetMsgFolderFromUri(uri);
		return folder.server;
	}
	catch (ex) {
		dump("GetServer("+uri+") failed, ex="+ex+"\n");
	}

	return null;
}

function FolderPaneOnClick(event)
{
	debug("in FolderPaneClick()\n");

	var t = event.originalTarget;
	var item;
	var uri;

	if (t.getAttribute('twisty') == 'true') {
		// The twisty is nested three below the treeitem:
		// <treeitem>
		//   <treerow>
		//	 <treecell>
		//		 <titledbutton class="tree-cell-twisty"> <!-- anonymous -->
		var treeitem = t.parentNode.parentNode.parentNode;
		var open = treeitem.getAttribute('open');
		if(open == "true") {
			//dump("twisty open\n");

			item = t.parentNode.parentNode.parentNode;
			if (item.localName == "treeitem") {
				var isServer = (treeitem.getAttribute('IsServer') == "true");
				if (isServer) {
					uri = treeitem.getAttribute("id");
					var server = GetServer(uri);
					if (server) {
						server.PerformExpand(msgWindow);
					}
				}
				else {
					var isImap = (treeitem.getAttribute('ServerType') == "imap");
					if (isImap) {
						uri = treeitem.getAttribute("id");
						var folder = GetMsgFolderFromUri(uri);
						if (folder) {
							var imapFolder = folder.QueryInterface(Components.interfaces.nsIMsgImapMailFolder);
							if (imapFolder) {
								imapFolder.PerformExpand(msgWindow);
							}
						}
					}
				}
			}
		}
	}
	else if(event.detail == 2)
	{
		item = t.parentNode.parentNode;
		if (item.localName == "treeitem")
			FolderPaneDoubleClick(item);
	}
}

function FolderPaneDoubleClick(treeitem)
{
	var isServer = false;

	if (treeitem) {
		isServer = (treeitem.getAttribute('IsServer') == "true");
		if (isServer) {
			var open = treeitem.getAttribute('open');
			if (open == "true") {
				var uri = treeitem.getAttribute("id");
				server = GetServer(uri);
				if (server) {
					//dump("double clicking open, PerformExpand()\n");
					server.PerformExpand(msgWindow);
				}
			}
			else {
				//dump("double clicking close, don't PerformExpand()\n");
			}
		}
	}

	// don't open a new msg window if we are double clicking on a server.
	// only do it for folders or newsgroups
	if (!isServer) {
		var pref = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
		var reuseMessenger = false;
		try
		{
			reuseMessenger = !pref.GetBoolPref("mailnews.open_folder_in_new_window");
		}
		catch(ex)
		{
		}
		MsgOpenNewWindowForFolder(treeitem.getAttribute('id'), reuseMessenger);
	}
}

function ChangeSelection(tree, newSelection)
{
	if(newSelection)
	{
		tree.clearItemSelection();
		tree.selectItem(newSelection);
		tree.ensureElementIsVisible(newSelection);
	}
}

function GetSelectedMsgFolders()
{
	var selectedFolders = gFolderTree.selectedItems;
	var numFolders = selectedFolders.length;

	var folderArray = new Array(numFolders);

	for(var i = 0; i < numFolders; i++)
		folderArray[i] = GetMsgFolderFromNode(selectedFolders[i]);
	return folderArray;
}

function GetSelectedMessage(index)
{
	return null;
}

function GetNumSelectedMessages()
{
	return 0;
}

function GetSelectedMessages()
{
	return null;
}

function GetLoadedMsgFolder()
{
	var selectedFolders = gFolderTree.selectedItems;
	if (selectedFolders.length == 1) return GetMsgFolderFromNode(selectedFolders[0]);
	return null;
}

function GetLoadedMessage()
{
	return null;

}

function GetCompositeDataSource(command)
{
	if(command == "GetNewMessages" || command == "DeleteMessages" || command == "Copy"  || 
	   command == "Move" ||  command == "NewFolder" ||  command == "MarkAllMessagesRead")
	{
		return GetFolderDatasource();
	}
	return null;

}

function SelectFolder(folderUri)
{
	var treeitem = document.getElementById(folderUri);
	if(gFolderTree && treeitem)
		ChangeSelection(gFolderTree, treeitem);
}

