/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code is Mozilla Communicator client code, released
 * March 31, 1998.
 * 
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation. Portions created by Netscape are
 * Copyright (C) 1998-2000 Netscape Communications Corporation. All
 * Rights Reserved.
 */

// DefaultController object (handles commands when one of the trees does not have focus)
var DefaultController =
{
   supportsCommand: function(command)
	{

		switch ( command )
		{
			case "cmd_delete":
			case "button_delete":
			case "cmd_undo":
			case "cmd_redo":
			case "cmd_renameFolder":
			case "cmd_getNewMessages":
			case "cmd_getNextNMessages":
			case "cmd_emptyTrash":
			case "cmd_compactFolder":
				return true;
			default:
				return false;
		}
	},

	isCommandEnabled: function(command)
	{
		switch ( command )
		{
			case "cmd_delete":
			case "button_delete":
				if ( command == "cmd_delete" )
					goSetMenuValue(command, 'valueFolder');
				var folderTree = GetFolderTree();
				if ( folderTree && folderTree.selectedItems && folderTree.selectedItems.length > 0)
				{
					var specialFolder = null;
					var isServer = null;
					var serverType = null;
					try {
						var selectedFolder = folderTree.selectedItems[0];
								specialFolder = selectedFolder.getAttribute('SpecialFolder');
								isServer = selectedFolder.getAttribute('IsServer');
						serverType = selectedFolder.getAttribute('ServerType');
					}
					catch (ex) {
						//dump("specialFolder failure: " + ex + "\n");
					}
					if (specialFolder == "Inbox" || specialFolder == "Trash" || isServer == "true")
						return false;
					else
						return true;
				}
				else
					return false;
			case "cmd_undo":
			case "cmd_redo":
				return SetupUndoRedoCommand(command);
			case "cmd_renameFolder":
				return IsRenameFolderEnabled();
			case "cmd_getNewMessages":
				return IsGetNewMessagesEnabled();
			case "cmd_getNextNMessages":
				return IsGetNextNMessagesEnabled();
			case "cmd_emptyTrash":
				return IsEmptyTrashEnabled();
			case "cmd_compactFolder":
				return IsCompactFolderEnabled();
			default:
				return false;
		}
		return false;
	},

	doCommand: function(command)
	{
   		//dump("ThreadPaneController.doCommand(" + command + ")\n");

		switch ( command )
		{
			case "cmd_delete":
			case "button_delete":
				MsgDeleteFolder();
				break;
			case "cmd_undo":
				messenger.Undo(msgWindow);
				break;
			case "cmd_redo":
				messenger.Redo(msgWindow);
				break;
			case "cmd_renameFolder":
				MsgRenameFolder();
				return;
			case "cmd_getNewMessages":
				MsgGetMessage();
				break;
			case "cmd_getNextNMessages":
				MsgGetNextNMessages();
				break;
			case "cmd_emptyTrash":
				MsgEmptyTrash();
				return;
			case "cmd_compactFolder":
				MsgCompactFolder();
				return;
		}
	},
	
	onEvent: function(event)
	{
		// on blur events set the menu item texts back to the normal values
		if ( event == 'blur' )
		{
			goSetMenuValue('cmd_delete', 'valueDefault');
			goSetMenuValue('cmd_undo', 'valueDefault');
			goSetMenuValue('cmd_redo', 'valueDefault');
		}
	}
};

function CommandUpdate_Mail()
{
	goUpdateCommand('button_delete');
	goUpdateCommand('cmd_delete');
	goUpdateCommand('cmd_nextMsg');
	goUpdateCommand('cmd_nextUnreadMsg');
	goUpdateCommand('cmd_nextUnreadThread');
	goUpdateCommand('cmd_nextFlaggedMsg');
	goUpdateCommand('cmd_previousMsg');
	goUpdateCommand('cmd_previousUnreadMsg');
	goUpdateCommand('cmd_previousFlaggedMsg');
	goUpdateCommand('cmd_sortByThread');
	goUpdateCommand('cmd_viewAllMsgs');
	goUpdateCommand('cmd_viewUnreadMsgs');
	goUpdateCommand('cmd_expandAllThreads');
	goUpdateCommand('cmd_collapseAllThreads');
	goUpdateCommand('cmd_renameFolder');
	goUpdateCommand('cmd_getNewMessages');
	goUpdateCommand('cmd_getNextNMessages');
	goUpdateCommand('cmd_find');
	goUpdateCommand('cmd_findAgain');
	goUpdateCommand('cmd_markAllRead');
	goUpdateCommand('cmd_emptyTrash');
	goUpdateCommand('cmd_compactFolder');
}

function SetupUndoRedoCommand(command)
{
	// dump ("--- SetupUndoRedoCommand: " + command + "\n");
	var canUndoOrRedo = false;
	var txnType = 0;

	try {
		if (command == "cmd_undo")
		{
			canUndoOrRedo = messenger.CanUndo();
			txnType = messenger.GetUndoTransactionType();
		}
		else
		{
			canUndoOrRedo = messenger.CanRedo();
			txnType = messenger.GetRedoTransactionType();
		}
	}
	catch (e) {
		dump(e);
	}

	if (canUndoOrRedo)
	{
		switch (txnType)
		{
		default:
		case 0:
			goSetMenuValue(command, 'valueDefault');
			break;
		case 1:
			goSetMenuValue(command, 'valueDeleteMsg');
			break;
		case 2:
			goSetMenuValue(command, 'valueMoveMsg');
			break;
		case 3:
			goSetMenuValue(command, 'valueCopyMsg');
			break;
		}
	}
	else
	{
		goSetMenuValue(command, 'valueDefault');
	}
	return canUndoOrRedo;
}


function CommandUpdate_UndoRedo()
{
	ShowMenuItem("menu_undo", true);
	EnableMenuItem("menu_undo", SetupUndoRedoCommand("cmd_undo"));
	ShowMenuItem("menu_redo", true);
	EnableMenuItem("menu_redo", SetupUndoRedoCommand("cmd_redo"));
}

function SetupCommandUpdateHandlers()
{
	dump("SetupCommandUpdateHandlers\n");
		
	top.controllers.insertControllerAt(0, DefaultController);
}

function IsRenameFolderEnabled()
{
	var tree = GetFolderTree();
	var folderList = tree.selectedItems;

	if(folderList.length == 1)
	{
		var folderNode = folderList[0];
		return(folderNode.getAttribute("CanRename") == "true");
	}
	else
		return false;

}

function IsFolderSelected()
{
	var tree = GetFolderTree();
	var folderList = tree.selectedItems;

	if(folderList.length == 1)
	{
		var folderNode = folderList[0];
		return(folderNode.getAttribute("IsServer") != "true");
	}
	else
		return false;
}

function MsgDeleteFolder()
{
	//get the selected elements
	var tree = GetFolderTree();
	var folderList = tree.selectedItems;
	var i;
	var folder, parent;
	var specialFolder;
	for(i = 0; i < folderList.length; i++)
	{
		folder = folderList[i];
		folderuri = folder.getAttribute('id');
		specialFolder = folder.getAttribute('SpecialFolder');
		if (specialFolder != "Inbox" && specialFolder != "Trash")
		{
			dump(folderuri);
			parent = folder.parentNode.parentNode;	
			var parenturi = parent.getAttribute('id');
			if(parenturi)
				dump(parenturi);
			else
				dump("No parenturi");
			dump("folder = " + folder.localName + "\n"); 
			dump("parent = " + parent.localName + "\n"); 
			messenger.DeleteFolders(tree.database,
				parent.resource, folder.resource);
		}
	}
}

function FillInFolderTooltip(cellNode)
{
	var folderNode = cellNode.parentNode.parentNode;
	var uri = folderNode.getAttribute('id');
	var folderTree = GetFolderTree();

	var name = GetFolderNameFromUri(uri, folderTree);

	var folderResource = RDF.GetResource(uri);
	var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
	var unreadCount = msgFolder.getNumUnread(false);
	if(unreadCount < 0)
		unreadCount = 0;

	var totalCount = msgFolder.getTotalMessages(false);
	if(totalCount < 0)
		totalCount = 0;

	var textNode = document.getElementById("foldertooltipText");
	var folderTooltip = name;
	if(!msgFolder.isServer)
		folderTooltip += " ("  + unreadCount + "/" + totalCount +")";
	textNode.setAttribute('value', folderTooltip);
	return true;
	

}

function GetFolderNameFromUri(uri, tree)
{
	var folderResource = RDF.GetResource(uri);

	var db = tree.database;

	var nameProperty = RDF.GetResource('http://home.netscape.com/NC-rdf#Name');

	var nameResult;
	try {
		nameResult = db.GetTarget(folderResource, nameProperty , true);
	}
	catch (ex) {
		return "";
	}

	nameResult = nameResult.QueryInterface(Components.interfaces.nsIRDFLiteral);
	return nameResult.Value;
}

function SwitchPaneFocus(event)
{
}

function SetFocusThreadPane()
{
	alert("Oops...");
}

function SetTemplateTreeItemOpen(open)
{
}

